﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;
using System.Globalization;

namespace CWM_gui
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {

            /*
            System.Globalization.CultureInfo curcustomCulture = (System.Globalization.CultureInfo)System.Threading.Thread.CurrentThread.CurrentCulture.Clone();
            curcustomCulture.NumberFormat.NumberDecimalSeparator = ",";

            System.Threading.Thread.CurrentThread.CurrentCulture = curcustomCulture;
            */
            richTextBox1.Clear();
            richTextBox3.Clear();
            double lenth = Convert.ToDouble(numericUpDown1.Value);
            double wire_r = Convert.ToDouble(numericUpDown2.Value);
            int coil_n = Convert.ToInt32(numericUpDown3.Value);
            int coil_pos = Convert.ToInt32(numericUpDown4.Value);
            double coil_d = Convert.ToDouble(numericUpDown5.Value);
            int f = Convert.ToInt32(numericUpDown6.Value);
            double k = Convert.ToDouble(numericUpDown7.Value); ; //tolerance (procenta)

            lenth = lenth * 0.975;

            double kz = k;
            k = 1 + (k / 100);

            wire_r = wire_r * k;

            string url = richTextBox4.Lines[0]; //(@"C:\Users\Mathias Palme\Documents\cwm\");
            string name = richTextBox2.Lines[0];

            richTextBox1.AppendText(name);


            string time = DateTime.Now.ToString("dd.M._HH.mm");
            Console.WriteLine("The current time is {0}", time);


            if (name == "název_souboru")
            {
                richTextBox2.Clear();
                richTextBox2.AppendText(time);
            }

            name = richTextBox2.Lines[0];

            using (StreamWriter sw = new StreamWriter(@"" + url + "/" + name + ".gcode", false))  //@"" + url + name + ".gcode"
            {
                sw.WriteLine(";délka cívky: {0} mm", lenth);
                sw.WriteLine(";průměr drátu: {0} mm", wire_r);
                sw.WriteLine(";Počet vinutí: {0}", coil_n);
                sw.WriteLine(";Počáteční vinutí: {0}", coil_pos);
                sw.WriteLine(";Rychlost navíjení: {0}", f);
                sw.WriteLine(";Tolerance je: {0} %\n", kz);
                sw.Flush();
            }



            double pi = 3.14159265358979000000;
            int n = 1;
            double coil_np = 0;
            double rlw = (lenth / wire_r);
            //int f = 15000;
            
            System.Globalization.CultureInfo customCulture = (System.Globalization.CultureInfo)System.Threading.Thread.CurrentThread.CurrentCulture.Clone();
            customCulture.NumberFormat.NumberDecimalSeparator = ".";

            System.Threading.Thread.CurrentThread.CurrentCulture = customCulture;

            richTextBox1.AppendText("\n");
            richTextBox1.AppendText("G92 X" + (wire_r * coil_pos) + " Y" + coil_pos + ";\n");
            /*Console.WriteLine();
            Console.Write("G92 X{0} Y{1};\n", (wire_r * coil_pos), coil_pos);
            */


            using (StreamWriter sw = new StreamWriter(@"" + url + "/" + name + ".gcode", true)) //C:\Users\Mathias Palme\Documents\cwm\"
            {
                sw.WriteLine("G92 X{0} Y{1};\n", (wire_r * coil_pos), coil_pos);
                sw.Flush();
            }
            
            while ((coil_np != coil_n) && (n < ((coil_n / rlw))))
            {
                if (n % 2 == 0)                 //even number
                {
                    //Console.Write("G1 X{1} Y{0} F{2};", ((lenth / wire_r) * n), 0, f);
                    using (StreamWriter sw = new StreamWriter(@"" + url + "/" + name + ".gcode", true))
                    {
                        sw.WriteLine("G1 X{1} Y{0} F{2};", ((lenth / wire_r) * n), 0, f);
                        sw.Flush();
                    }

                    n++;
                    coil_np = coil_np + rlw;
                }
                else
                {
                    //Console.Write("G1 X{1} Y{0} F{2};", ((lenth / wire_r) * n), lenth, f);

                    using (StreamWriter sw = new StreamWriter(@"" + url + "/" + name + ".gcode", true))
                    {
                        sw.WriteLine("G1 X{1} Y{0} F{2};", ((lenth / wire_r) * n), lenth, f);
                        sw.Flush();
                    }

                    n++;
                    coil_np = coil_np + rlw;

                }
                //Console.WriteLine();

                if (coil_np > coil_n)
                {
                    break;
                }
            }

            if (n % 2 == 0)                 //even number
            {
                //Console.Write("G1 X{1} Y{0} F{2};", (((lenth / wire_r) * (n - 1)) + (coil_n - coil_np)), 0, f);
                
                using (StreamWriter sw = new StreamWriter(@"" + url + "/" + name + ".gcode", true))
                {
                    sw.WriteLine("G1 X{1} Y{0} F{2};", (((lenth / wire_r) * (n - 1)) + (coil_n - coil_np)), 0, f);
                    sw.Flush();
                }

                n++;
                coil_np = coil_np + rlw;
            }
            else
            {
                //Console.Write("G1 X{1} Y{0} F{2};", (((lenth / wire_r) * (n - 1)) + (coil_n - coil_np)), lenth, f);

                using (StreamWriter sw = new StreamWriter(@"" + url + "/" + name + ".gcode", true))
                {
                    sw.WriteLine("G1 X{1} Y{0} F{2};", (((lenth / wire_r) * (n - 1)) + (coil_n - coil_np)), lenth, f);
                    sw.Flush();
                }

                n++;
                coil_np = coil_np + rlw;
                //Console.WriteLine(coil_np);
            }
            //Console.WriteLine("\nG92 Y0;");

            //výpočet délky drátu
            double wire_l = pi * (wire_r / 2 + wire_r) * (wire_r / 2 + wire_r) * (lenth / wire_r);

            for (int i = 1; i < n; i++)
            {
                wire_l = wire_l + pi * (wire_r / 2 + i * wire_r) * (wire_r / 2 + i * wire_r) * (lenth / wire_r);
            }

            //Console.WriteLine("\n\nVýsledná délka drátu bude: {0} metrů", (wire_l / 1000));

            //double ohm = ( (17/1000000000) * (wire_l/1000) ) / (pi * Math.Pow((wire_r / 2000), 2) );

            //Console.WriteLine("\nvysledný odpor cívky bude: {0} ohmů", ohm);


            using (StreamWriter sw = new StreamWriter(@"" + url + "/" + name + ".gcode", true))
            //using (StreamWriter sw = new StreamWriter(@"" + url, true))
            {
                sw.WriteLine("\nG92 Y0;");
                sw.Flush();
            }


            

            richTextBox1.Text = File.ReadAllText(@"" + url + "/" + name + ".gcode");
            Console.WriteLine("\n\nVýsledný průmer cívky je: {0} mm", ((coil_d) + ((n - 1) * wire_r * 2)));
            richTextBox3.AppendText("Výsledný průmer cívky bude: " + ((coil_d) + ((n - 1) * wire_r * 2)) + " mm");

        }

        private void richTextBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void richTextBox3_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
