﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;

namespace Coil_gun_gui_bluetooth
{
    public partial class Form1 : Form
    {
        int n = 0;

        delegate void serialCalback(string val);

        public Form1()
        {
            InitializeComponent();


        }



        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.Items.Add("COM1");
            comboBox1.Items.Add("COM2");
            comboBox1.Items.Add("COM3");
            comboBox1.Items.Add("COM4");
            comboBox1.Items.Add("COM5");
            comboBox1.Items.Add("COM6");
            comboBox1.Items.Add("COM7");

            comboBox1.Text = "COM7";
        }


        private void button2_Click(object sender, EventArgs e)
        {
            if (n == 0)
            {
                n = 1;
                string port = comboBox1.Text;
                serialPort1.PortName = port;
                serialPort1.BaudRate = 9600;
                serialPort1.Open();

                try
                {
                    if (!serialPort1.IsOpen)
                        serialPort1.Open();
                        richTextBox1.AppendText("Conection succeful...\n");
                        richTextBox1.ScrollToCaret();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }

            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            n = 0;
            serialPort1.Close();
            richTextBox1.AppendText("Conection lost...\n");
        }

        private void button4_Click(object sender, EventArgs e)
        {

            if(serialPort1.IsOpen == true)
            {
                int nc = Convert.ToInt32(numericUpDown1.Value); //numeber of coils
                serialPort1.Write("s"); // send value to Arduino
                string pa = Convert.ToString(numericUpDown1.Value); // read number of coils from nzmericUpDown box
                serialPort1.Write(pa); //send new number of coils to Arduino
                richTextBox1.AppendText("Shooting using " + nc + " coils...");

                string time = ""; 

                while(time == "")
                {
                    time = serialPort1.ReadLine();
                }


                double timeINT = double.Parse(time);
                timeINT = timeINT / 1000000;
                double v = 0.025 / timeINT ;

                string speed = v.ToString();


                //richTextBox1.AppendText(time);
                richTextBox1.AppendText("\n" + speed + " m/s\n\n");
                Console.Write("\ntime: {0}", time);
                Console.WriteLine("speed: {0} m/s", speed);

                Clipboard.SetDataObject(speed);
                time = "";
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");

            }

        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("1");
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");

            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("0");
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {
            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("0"); //send command "2" to Arduino

                string coil_time = "";

                while (coil_time == "")
                {
                    coil_time = serialPort1.ReadLine();
                }


                richTextBox1.AppendText("Discharge time (ms) = " + coil_time);
                Clipboard.SetDataObject(coil_time);

                coil_time = "";
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            richTextBox1.Clear();
        }

        private void button8_Click(object sender, EventArgs e)
        {

        }

        private void button8_Click_1(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("a");
                richTextBox1.AppendText("Testing coil 1...\n");
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button9_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("b");
                richTextBox1.AppendText("Testing coil 2...\n");
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button11_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("c");
                richTextBox1.AppendText("Testing coil 3...\n");
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("d");
                richTextBox1.AppendText("Testing coil 4...\n");
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }
        
        private void button12_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("e");
                richTextBox1.AppendText("Testing coil 5...\n");
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {

        }

        private void button5_Click_1(object sender, EventArgs e) //discharge all capacitors
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("y");
                richTextBox1.AppendText("Discharging capacitors...\n");
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button6_Click_1(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                var xy = numericUpDown2.Value; //read time value from numericUpDown2
                String xyz = xy.ToString(); //convert time vlaue to string
                serialPort1.Write("t"); // send command "t" to Arduino
                serialPort1.Write(xyz); // send time value as a string
                richTextBox1.AppendText("Discharge time is set to: " + xyz + "\n");
                richTextBox1.ScrollToCaret();
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
                richTextBox1.ScrollToCaret();
            }
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void button13_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                decimal valx = numericUpDown3.Value;
                decimal valy = numericUpDown4.Value;
                decimal valz = numericUpDown5.Value;
                decimal vala = numericUpDown6.Value;
                serialPort1.Write("X" + valx);
                serialPort1.Write("Y" + valy);
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button14_Click(object sender, EventArgs e)
        {
            if(serialPort1.IsOpen == true)
            {
                serialPort1.Write("hx");
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {

        }

        private void button15_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                decimal valy = numericUpDown4.Value;
                serialPort1.Write("Y" + valy);
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button16_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                decimal valz = numericUpDown5.Value;
                serialPort1.Write("z" + valz);
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button17_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                decimal vala = numericUpDown6.Value;
                serialPort1.Write("A" + vala);
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button18_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("hy");
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button19_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("hz");
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

        private void button20_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Write("ha");
            }
            else
            {
                richTextBox1.AppendText("Bluetooth is not conected\n");
            }
        }

    }
}
